//   RW Pandora
// ==============
// Demonstration of an Arigato-grade robowaifu
// -Part of the RW Foundations suite of libraries

// Filename: ./include/arigato/pandora.hpp
// -Declarations of the baseline RW Pandora project subsystem

#pragma once

#include "incls_all.hpp"

namespace rw::arigato {

//------------------------------------------------------------------------------
/**
 */
class Pandora_b : public Arigato {
 public:
  Pandora_b();                                    // default ctor
  explicit Pandora_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
/**
 */
class Pandora : public Pandora_b {
 public:
  Pandora();                                    // default ctor
  explicit Pandora(std::string const& handle);  // tag-parm'd ctor

  auto do_preflight() -> bool override;

  inline auto graphicom() const -> Graphicom& { return graphicom_; }

 private:
  unique_ptr<Graphicom_b> _graphicom_{
      make_unique<Graphicom_b>("pandora_graphicom")};

  Graphicom& graphicom_{reference_to<Graphicom>(_graphicom_.get())};
};

}  // namespace rw::arigato

//    --=^=--

// "______"

// rw_arigato_lib.v220507
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
