//   RW Curator
// ==============
// Search, Information, and Data Storage, Retrieval, & Optimizations Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/curator.hpp
// -Declarations of the baseline RW Curator library

#pragma once

#include "incls_all.hpp"

namespace rw::curator {

//------------------------------------------------------------------------------
/**
 */
class Curator_b : public RW {
 public:
  Curator_b();                                    // default ctor
  explicit Curator_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
/**
 */
class Curator : public Curator_b {
 public:
  Curator();                                    // default ctor
  explicit Curator(std::string const& handle);  // tag-parm'd ctor

  inline auto waifusearch() const -> Waifusearch& { return waifusearch_; }

 private:
  unique_ptr<Waifusearch_b> _waifusearch_{
      make_unique<Waifusearch_b>("curator_waifusearch")};

  Waifusearch& waifusearch_{reference_to<Waifusearch>(_waifusearch_.get())};

///////
// Dolldrop/Dollnet is meant for network-enabled RW projects only
#if __has_include(<curl_easy.h>)

 public:
  inline auto dolldrop() const -> Dolldrop& { return dolldrop_; }

 private:
  unique_ptr<Dolldrop_b> _dolldrop_{
      make_unique<Dolldrop_b>(t(), "curator_dolldrop")};

  Dolldrop& dolldrop_{reference_to<Dolldrop>(_dolldrop_.get())};

#endif  // __has_include(<curl_easy.h>)
};

}  // namespace rw::curator

//    --=^=--

// "______"

// rw_curator_lib.v220507
// Copyright (2022)
// License MIT (Expat) https://opensource.org/licenses/MIT
